using MosaikAPIv3
using Documenter
import Documenter.Remotes.GitLab

DocMeta.setdocmeta!(MosaikAPIv3, :DocTestSetup, :(using MosaikAPIv3); recursive=true)

makedocs(;
    modules=[MosaikAPIv3],
    checkdocs=:exports,
    authors="Eike Schulte<eike.schulte@offis.de>, Malte Stomberg<malte.stomberg@offis.de>",
    repo=GitLab("mosaik", "api/MosaikAPIv3.jl"),
    sitename="MosaikAPIv3.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://mosaik.gitlab.io/api/MosaikAPIv3.jl/",
        edit_link="main",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
    ],
)
