using MosaikAPIv3
using Test
using Logging

mutable struct GetProgressSim <: MosaikAPIv3.Simulator
    models::Dict{Symbol,NamedTuple{(:type, :count),Tuple{DataType,Int}}}
    entities::Dict{String,String}
    event_happened::Bool
    mosaik_remote::MosaikAPIv3.MosaikRemote
    sim_id::String
    function GetProgressSim()
        new(Dict(), Dict(), false)
    end
end

function MosaikAPIv3.init(
    ::Type{GetProgressSim},
    mosaik_remote::MosaikAPIv3.MosaikRemote,
    sim_id::String,
    time_resolution::Float64,
)
    my_sim = GetProgressSim()
    my_sim.mosaik_remote = mosaik_remote
    my_sim.models[Symbol("AsyncRequestsTest")] = (type = GetProgressSim, count = 0)
    my_sim.sim_id = sim_id
    my_sim
end

MosaikAPIv3.meta(::GetProgressSim) = MosaikMeta(;
    type = MosaikAPIv3.time_based,
    models = Dict(
        :AsyncRequestsTest => Model(;
            public = true, 
            params = [], 
            attrs = [:value]),
    ),
)

function MosaikAPIv3.step!(my_sim::GetProgressSim, time, inputs, max_advance)
    @test test_progress(my_sim.mosaik_remote, time)
    time + 1
end

function test_progress(mosaik_remote::MosaikRemote, time::Int)
    time * 10 == MosaikAPIv3.get_progress(mosaik_remote)
end

function MosaikAPIv3.finalize!(::GetProgressSim)
    @info "Finalizing async requests"
end

MosaikAPIv3.run_server(GetProgressSim)