from __future__ import annotations

from mosaik import util
import mosaik
import mosaik.basic_simulators
from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from mosaik.scenario import SimConfig

SIM_CONFIG: SimConfig = {
    'InputSim': {
        'python': 'mosaik.basic_simulators:InputSimulator'
    },
    "AsyncRequestsJulia": {
        "connect": "localhost:2000",
    }
}

world = mosaik.World(SIM_CONFIG)
julia_creator = world.start("AsyncRequestsJulia")
julia_sims = julia_creator.AsyncRequestsTest.create(2)

input = world.start('InputSim', step_size=1)
input_model_const = input.Constant.create(3, constant=2)

world.connect(input_model_const[0], julia_sims[0], 'value')
util.connect_many_to_one(world=world, src_set={
    input_model_const[1],
    input_model_const[2]},
    dest=julia_sims[1]
    )

world.run(until=10)
