from __future__ import annotations
from typing import Any, Dict, cast
import mosaik
import mosaik.basic_simulators
from mosaik.scenario import SimConfig

SIM_CONFIG: SimConfig = {
    'OutputSim': {
        'python': 'mosaik.basic_simulators:OutputSimulator'
    },
    "Input_Julia": {
        "connect": "localhost:2000",
    }
}

test_constant = 2

world = mosaik.World(SIM_CONFIG)
julia_creator = world.start("Input_Julia")
julia_sims = julia_creator.Constant.create(2, constant=test_constant)

output = world.start('OutputSim')
output_sims = output.Dict.create(2)

world.connect( julia_sims[0], output_sims[0], 'value')

test_dict: Dict[int, Dict[str, Any]] = cast(
    Dict[int, Dict[str, Any]], output.get_dict(output_sims[0].eid)
)
test_input_eid = julia_sims[0].sid + "." + julia_sims[0].eid
print(test_input_eid)
world.run(until=10)

assert test_dict != {}
assert len(test_dict) == 10
for key in test_dict:
    print(test_dict[key])
    assert test_dict[key]["value"][test_input_eid]['constant'] == test_constant