from __future__ import annotations

import mosaik
import mosaik.basic_simulators
from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from mosaik.scenario import SimConfig

SIM_CONFIG: SimConfig = {
    'InputSim': {
        'python': 'mosaik.basic_simulators:InputSimulator'
    },
    "Output_Julia": {
        "connect": "localhost:2000",
    }
}

world = mosaik.World(SIM_CONFIG)
julia_creator = world.start("Output_Julia")
julia_sims = julia_creator.Output_Julia.create(2)

input = world.start('InputSim', step_size=1)
input_model_const = input.Constant.create(2, constant=2)

world.connect(input_model_const[0], julia_sims[0], 'value')

world.run(until=10)
